grammar org.sif.dsl.Sat with org.eclipse.xtext.common.Terminals

generate sat "http://www.sif.org/dsl/Sat"

Start returns Start:
	Check { Start.checks += current } (checks += Check)*
;

Check returns Check:
	"Check" formula = Biimplies "using" solver = SatSolver ";"
;

SatSolver:
	name = "SAT4J" |
	name = "minisat" |
	name = "picosat"
;

Biimplies returns Formula:
	Implies ({Biimplies.left = current} '<=>' right=Implies)*;

Implies returns Formula:
	Or ({Implies.left = current} '=>' right=Or)*;

Or returns Formula:
	Excludes ({Or.left = current} 'or' right=Excludes)*;

Excludes returns Formula:
	And ({Excludes.left = current} 'nand' right=And)*;
	
And returns Formula:
	(Not | Primary) ({And.left = current} 'and' right=(Not | Primary))*;
	
Not returns Formula:
	'~' Primary {Not.right = current};
	
Primary returns Formula:
	Variable | PFormula;
	
Variable returns Formula:
	id=ID;

PFormula returns Formula:
	'(' Biimplies { PFormula.expr = current } ')';
